Attribute VB_Name = "basParam"
Option Explicit

' p[^L[
Public Const csPosition         As String = "Position"
Public Const csTimer            As String = "Timer"
Public Const csTabKey           As String = "TabKey"

' ftHgl
Public Const ciDefPosition      As Integer = 33
Public Const ciDefTimer         As Integer = 100

' o[
Private mlPosition          As Long         ' }EẌʒu
Private mlTimer             As Long         ' ^C}[荞ݎ
Private mbTabKey            As Boolean      ' ^uL[

Public Property Get gsParamValue(ByVal psParamKey As String) As Variant
'---------------------------------------------------------------------------
'    : gsParamValue()
' @@@\ : p[^l̎擾
' @@ : (I) psParamKey     p[^L[
'   l : p[^l
' @@ : 2002/11/21
'---------------------------------------------------------------------------
    Select Case psParamKey
    Case csPosition
        gsParamValue = mlPosition
    Case csTimer
        gsParamValue = mlTimer
    Case csTabKey
        gsParamValue = mbTabKey

    End Select
End Property

Public Property Let gsParamValue(ByVal psParamKey As String, ByVal pvParamValue As Variant)
'---------------------------------------------------------------------------
'    : gsParamValue()
' @@@\ : p[^l̐ݒ
' @@ : (I) psParamKey     p[^L[
'          : (I) pvParamValue   p[^l
'   l : Ȃ
' @@ : 2002/11/21
'---------------------------------------------------------------------------
    Select Case psParamKey
    Case csPosition
        mlPosition = pvParamValue
    Case csTimer
        mlTimer = pvParamValue
    Case csTabKey
        mbTabKey = pvParamValue

    End Select
End Property

Public Function gsReadIniFile() As Boolean
'---------------------------------------------------------------------------
'    : gsReadIniFile()
' @@@\ : p[^t@Cǂݍ
' @@ : Ȃ
'   l : True= , False= s
' @@ : 2002/11/21
'---------------------------------------------------------------------------
    Dim liFileNo        As Integer          ' t@Cԍ
    Dim lsFileName      As String           ' t@C
    Dim lsLine          As String           ' ǂݍݕ
    Dim lsKeyStr        As String           ' p[^L[
    Dim liEqlPos        As Integer          ' ̈ʒu
    Dim lsPrmStr        As String           ' p[^l
    Dim lsAppPath       As String           ' AvP[ṼpX

    On Error GoTo gsReadIniFile_Error

    lsAppPath = App.Path
    If Right(lsAppPath, 1) = "\" Then
        lsFileName = lsAppPath & App.ProductName & ".ini"
    Else
        lsFileName = lsAppPath & "\" & App.ProductName & ".ini"
    End If
    liFileNo = FreeFile

    mlPosition = ciDefPosition
    mlTimer = ciDefTimer
    mbTabKey = False

    Open lsFileName For Input Access Read As liFileNo
    On Error Resume Next
    Do While Not EOF(liFileNo)
        Line Input #liFileNo, lsLine
        lsLine = LTrim(lsLine)
        liEqlPos = InStr(lsLine, "=")

        If liEqlPos > 0 Then
            lsKeyStr = Left$(lsLine, liEqlPos - 1)
            lsPrmStr = Mid$(lsLine, liEqlPos + 1)

            Select Case UCase(Trim(lsKeyStr))
            Case UCase(csPosition)
                mlPosition = CLng(lsPrmStr)

            Case UCase(csTimer)
                mlTimer = CLng(lsPrmStr)

            Case UCase(csTabKey)
                mbTabKey = CBool(lsPrmStr)

            End Select
        End If
    Loop

    Close liFileNo
    gsReadIniFile = True
    Exit Function

gsReadIniFile_Error:
    Close liFileNo
    gsReadIniFile = False
End Function

Public Function gsWriteIniFile() As Boolean
'---------------------------------------------------------------------------
'    : gsWriteIniFile()
' @@@\ : ݒt@C̏
' @@ : Ȃ
'   l : True= , False= s
' @@ : 2002/11/21
'---------------------------------------------------------------------------
    Dim liFileNo        As Integer          ' t@Cԍ
    Dim lsIniFile       As String           ' ݒt@C
    Dim liRetCode       As Integer          ' ߂l
    Dim lsAppPath       As String           ' AvP[ṼpX

    On Error GoTo gsWriteIniFile_Error

    lsAppPath = App.Path
    If Right(lsAppPath, 1) = "\" Then
        lsIniFile = lsAppPath & App.ProductName & ".ini"
    Else
        lsIniFile = lsAppPath & "\" & App.ProductName & ".ini"
    End If
    liFileNo = FreeFile

    Open lsIniFile For Output Access Write As liFileNo
    Print #liFileNo, "[" & App.ProductName & "]"
    Print #liFileNo, ""

    If mlPosition <> ciDefPosition Then
        Print #liFileNo, csPosition & "=" & mlPosition
    End If
    If mlTimer <> ciDefTimer Then
        Print #liFileNo, csTimer & "=" & mlTimer
    End If
    If mbTabKey <> False Then
        Print #liFileNo, csTabKey & "=" & mbTabKey
    End If

    Close liFileNo
    gsWriteIniFile = True
    Exit Function

gsWriteIniFile_Error:
    liRetCode = MsgBox("ݒt@C݂̏Ɏs܂B" & vbCrLf & lsIniFile, vbCritical Or vbRetryCancel, "G[")
    If liRetCode = vbRetry Then
        Resume
    End If
    Close #liFileNo
    gsWriteIniFile = False
End Function
